"""
    Utilities to generate OpenFOAM discharge curve case
"""

# Copyright (C) 2021 OST Ostschweizer Fachhochschule
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program. If not, see <http://www.gnu.org/licenses/>.

# Author: Juan Pablo Carbajal <ajuanpi+dev@gmail.com>
import shutil
from textwrap import dedent, indent
from pathlib import Path
from string import Template
from collections.abc import Iterable
import os

import numpy as np

from . import discharge_case_path
from . import physical_properties as pp
from . import casefiles as cf
from . import py2foam as p2f
from . import stltools as stl
from . import refinement_regions as refr


class DischargeCase:
    """Class for managing a basic discharge OpenFOAM simulation case.

    Parameters
    ----------
    cad_files: :class:`dict` of :class:`str` or :class:`pathlib.Path`
        Dictionary with the path to the required STL files. The keys of the
        dictionary must be

        - ``housing`` the housing geometry (the physical walls in the domain)
        - ``inlet``, ``outlet``, ``cover``  inlet, outlet, and cover patches.

    inner_point: :class:`numpy.array` or :class:`list`
        A point (x,y, z) inside the housing, to define what will be meshed.
        This parameter is currently mandatory, as the automatic calculation
        is not implemented yet.
    temperature: :class:`float`
        Temperature in Celsius used to calculate all temperature-dependent
        magnitudes.
    inflow: :class:`float`
        Inflow in L/min used in the inlet boundary condition.
    atmospheric_pressure: :class:`float`
        Atmospheric pressure in Pa.
    duration: :class:`float`
        Duration of the simulation, in seconds.
    start_time: :class:`float`
        Starting time of the simulation, in seconds.
    write_interval: :class:`float`
        Interval between CFD outputs written to file, in seconds.
    base_mesh_size: :class:`float`
        Size in meters of the background or base mesh generated by `BlockMesh <https://cfd.direct/openfoam/user-guide/v8-blockmesh/>_`.
        The background mesh will have cubic cells with the given size in each spatial direction.
    ics: :class:`list` of :class:`dict` or :class:`dict`
        Initial conditions: dictionaries describing `OpenFOAM topological sets <https://cpp.openfoam.org/v8/classFoam_1_1topoSetSource.html>`_
        to set initial conditions.
    parametrized_case_folder: :class:`str` or :class:`pathlib.Path`
        Path to the parametrized case folder. Templates will be used from
        this path instead of the default :data:`cfd_qsense.discharge_case_path`.
    cad_scale: :class:`float`
        Numerical factor to convert the CAD files into meters. For example
        if the value 1 in the CAD file represents one millimeter, then
        ``cad_scale = 1e-3``.
    water_level: :class:`float`
        Water level in the same units as the CAD file. This imposes an
        initial condition where the housing is filled with water up to the
        given level. The additional initial conditions given in :attr:`ics`
        are processed after the water level is set.
    probe_positions: :class:`numpy.ndarray`, shape (# probes, 3)
        Position of the probes on which the fields in the simulation are
        extracted. If not given, a single probe at :attr:`inner_point` is used.
    probe_write_interval: :class:`float`
        Sampling period of the probes in seconds. Default is :attr:`write_interval` / 10.
    probe_fields: :class:`list` of :class:`str`
        Name of the fields to be sampled by the probes. Defaults are the
        standard OpenFOAM field names for water fraction, pressure
        and velocity: ``['alpha.water', 'p', 'U']``.

    """

    def __init__(
        self,
        *,
        cad_files,
        inner_point,
        temperature=8.0,
        inflow=0.0,
        atmospheric_pressure=101.325e3,
        duration=30,
        start_time=0.0,
        write_interval=0.5,
        base_mesh_size=None,
        ics=None,
        parametrized_case_folder=None,
        cad_scale=1.0,
        water_level=None,
        probe_positions=None,
        probe_write_interval=None,
        probe_fields=None,
    ):
        """Initialize a discharge case object."""
        # Physical properties
        self._temperature = temperature
        self._atmospheric_pressure = atmospheric_pressure

        self._water = pp.Water(temperature=temperature, pressure=atmospheric_pressure)
        self._air = pp.Air(
            temperature=temperature, pressure=atmospheric_pressure, humidity=0.99
        )
        self._inflow = inflow

        # Simulation timing control
        self.start_time = start_time
        self.duration = duration
        self.write_interval = write_interval

        # CAD files
        self.cad_scale = cad_scale
        self.cad_files = {
            k: Path(cad_files[k]) for k in ("housing", "inlet", "outlet", "cover")
        }

        # Mesh
        self.base_mesh_size = 0.1 if base_mesh_size is None else base_mesh_size
        self.inner_point = np.asarray(inner_point)

        # Initial conditions
        self._ics = ""
        self._water_level = None
        self.water_level = water_level
        if ics is not None:
            self.initial_conditions_append(ics)

        # Sampling probes
        self.probe_positions = (
            self.inner_point.reshape(1, 3)
            if probe_positions is None
            else probe_positions
        )
        self.probe_write_interval = (
            self.write_interval / 10
            if probe_write_interval is None
            else probe_write_interval
        )
        self.probe_fields = (
            ["alpha.water", "p", "U"] if probe_fields is None else probe_fields
        )

        # Template file paths
        if parametrized_case_folder is not None:
            self.parametrized_case_folder = Path(parametrized_case_folder)
        else:
            self.parametrized_case_folder = discharge_case_path

        self.root_tmpl = Path("include")
        self.geometry_tmpl = self.root_tmpl / "geometricParameters.tmpl"
        self.physics_tmpl = self.root_tmpl / "physicalParameters.tmpl"
        self.case_tmpl = self.root_tmpl / "caseParameters.tmpl"
        self.ics_tmpl = self.root_tmpl / "initialConditions.tmpl"
        self.stl_path = Path("constant") / "triSurface"
        # storage for refinement regions
        self._refinement_boxes = []

    @property
    def temperature(self):
        return self._temperature

    @temperature.setter
    def temperature(self, C):
        self._temperature = C
        # Update physical properties of substances
        self._water.temperature = C
        self._air.temperature = C

    @property
    def atmospheric_pressure(self):
        return self._atmospheric_pressure

    @atmospheric_pressure.setter
    def atmospheric_pressure(self, P):
        self._atmospheric_pressure = P
        # Update physical properties of substances
        self._water.pressure = P
        self._air.pressure = P

    @property
    def inflow(self):
        return self._inflow

    @inflow.setter
    def inflow(self, Q):
        self._inflow = Q

    @property
    def air(self):
        return self._air

    @property
    def water(self):
        return self._water

    @property
    def end_time(self):
        return self.start_time + self.duration

    @property
    def water_level(self):
        """Water level in meters."""
        return self._water_level

    @water_level.setter
    def water_level(self, lvl):
        if lvl is not None:
            self._water_level = lvl
            xlim, ylim, zlim = stl.coord_ranges(self.cad_files["housing"])
            # base_mesh_size rounded to mm precision
            lim_ = np.row_stack((xlim, ylim, zlim))
            lim_ = lim_ * self.cad_scale * 1e3
            lim_ = lim_ + np.asarray([-self.base_mesh_size, self.base_mesh_size])
            lim_[:, 0] = np.floor(lim_[:, 0]) / 1e3
            lim_[:, 1] = np.ceil(lim_[:, 1]) / 1e3
            xlim, ylim, zlim = lim_

            zlim[1] = min(zlim[0] + self._water_level, zlim[1])
            b2c = box2cell(
                box_min=[xlim[0], ylim[0], zlim[0]],
                box_max=[xlim[1], ylim[1], zlim[1]],
                field="alpha.water",
                value=1.0,
            )
            # Erases all other initial conditions
            self.initial_conditions = b2c

    @property
    def initial_conditions(self):
        return self._ics

    @initial_conditions.setter
    def initial_conditions(self, ics):
        if ics is None:
            self._ics = ""
            return

        if not isinstance(ics, list):
            ics = [ics]
        self._ics = "\n".join(p2f.dict2foam(ic) for ic in ics)

    def initial_conditions_append(self, ics):
        if not isinstance(ics, list):
            ics = [ics]
        self._ics += "\n".join(p2f.dict2foam(ic) for ic in ics)

    def create_refinement_box(
        self, *, name: str, vmin: np.ndarray, vmax: np.ndarray, level: int
    ):
        box = refr.RefinementBox(name=name, vmin=vmin, vmax=vmax, level=level)
        self._refinement_boxes.append(box)

    def append_refinement_box(self, box: refr.RefinementBox):
        self._refinement_boxes.append(box)

    @property
    def refinement_boxes(self) -> tuple[dict, dict]:
        # collect refinement boxes into single dictionary
        regs = {}
        pars = {}
        for reg in self._refinement_boxes:
            regs.update(reg.region)
            pars.update(reg.parameters)
        return regs, pars

    def file_physical_properties(self, out_path=False, **kwargs):
        """String representation of the physical properties file."""
        infile = self.parametrized_case_folder / self.physics_tmpl
        content, outfile = cf.file_from_template(
            infile,
            output=out_path,
            water_kinematic_viscosity=self._water.viscosity_kinematic,
            water_density=self._water.density,
            air_kinematic_viscosity=self._air.viscosity_kinematic,
            air_density=self._air.density,
            water_air_surface_tension=self._water.surface_tension,
            **kwargs,
        )
        return content, outfile

    def file_case_parameters(self, out_path=False, **kwargs):
        """String representation of the case parameters file."""
        # Convert inflow from L/min to m³/s
        inflow_to_m3sec = 1.0e-3 / 60.0
        inflow_metric = self.inflow * inflow_to_m3sec
        # probes
        probes = p2f.iter2foam(self.probe_positions)
        fields = p2f.iter2foam(self.probe_fields)

        infile = self.parametrized_case_folder / self.case_tmpl
        content, outfile = cf.file_from_template(
            infile,
            output=out_path,
            atmospheric_pressure=self.atmospheric_pressure,
            inflow=inflow_metric,
            start_time=self.start_time,
            end_time=self.end_time,
            write_interval=self.write_interval,
            probes=probes,
            write_interval_probes=self.probe_write_interval,
            field_probes=fields,
            **kwargs,
        )
        return content, outfile

    def file_initial_conditions(self, out_path=False, **kwargs):
        """String representation of the initial conditions file."""
        infile = self.parametrized_case_folder / self.ics_tmpl
        content, outfile = cf.file_from_template(
            infile, output=out_path, housing_ic=self.initial_conditions, **kwargs
        )
        return content, outfile

    def file_geometry(self, out_path=False, **kwargs):
        """String representation of the geometric information file."""
        # bounding box vertices
        bb = stl.bounding_box_from_stl(self.cad_files["housing"]) * self.cad_scale
        bb_ = p2f.iter2foam(bb)
        # internal point
        inp_ = p2f.iter2foam(self.inner_point)
        # background mesh size with square aspect
        range = (bb.max(axis=0) - bb.min(axis=0)).flatten()
        nx, ny, nz = np.ceil(range / self.base_mesh_size).astype(int)
        # convert stl names to strings
        stls = {k: p2f.foam_string(v.name) for k, v in self.cad_files.items()}
        infile = self.parametrized_case_folder / self.geometry_tmpl

        # convert refinement regions to foam strings
        regs, pars = self.refinement_boxes
        refreg = p2f.dict2foam(regs, outer_braces=True)
        refregp = p2f.dict2foam(pars, outer_braces=True)

        # scale STL
        # All STLs will be scaled after they are copied. Hence the OpenFOAM
        # STL scale is 1.0 instead of self.cad_scale
        content, outfile = cf.file_from_template(
            infile,
            output=out_path,
            **stls,
            stl_scale=1.0,
            bb_vertices=bb_,
            nx=nx,
            ny=ny,
            nz=nz,
            inner_point=inp_,
            refinement_regions=refreg,
            refinement_region_parameters=refregp,
            **kwargs,
        )

        return content, outfile

    def __str__(self):
        cads = "\n".join(f"{k}: " + str(v) for k, v in self.cad_files.items())
        txt = f"""\
        Discharge case
          Temperature: {self.temperature} C
          Inflow: {self.inflow} L/min
          Atm. Pressure: {self.atmospheric_pressure} Pa
          CAD files:
{indent(cads, " "*12)}"""

        if self._ics:
            ics = indent("Initial conditions\n", " " * 10)
            if self._water_level is not None:
                ics += indent(f"Water level: {self._water_level} m\n", " " * 12)
            ics += indent(self.initial_conditions, " " * 12)
            txt = "\n".join((txt, ics))
        return dedent(txt)

    def _recursive_chmod(self, path, mode):
        for dirpath, dirnames, filenames in os.walk(path):
            os.chmod(dirpath, mode)
            for filename in filenames:
                os.chmod(os.path.join(dirpath, filename), mode)

    def write_files(self, *, case_folder, overwrite=False, **kwargs):
        """Write to disk all case files.

        Parameters
        ----------
        case_folder: :class:`pathlib.Path`
            Destination case folder. It will contain the case files.
        overwrite: :class:`bool`
            If True, existing folders and files in ``case_folder`` are overwritten.
        kwargs:
            Extra keyword arguments passed to all case file generators.
        """
        case_folder = Path(case_folder)
        # Copy parametrized case to destination case folder
        shutil.copytree(
            src=self.parametrized_case_folder, dst=case_folder, dirs_exist_ok=overwrite
        )
        self._recursive_chmod(case_folder, 0o744)
        # remove python related files if found
        to_remove = ["__init__.py", "__pycache__"]
        for f in to_remove:
            f_ = (case_folder / f).resolve()
            if f_.exists():
                if f_.is_dir():
                    shutil.rmtree(f_)
                else:
                    f_.unlink()

        # Replace templates with values
        for func in (
            self.file_physical_properties,
            self.file_case_parameters,
            self.file_initial_conditions,
            self.file_geometry,
        ):
            _, outf_ = func(out_path=case_folder / self.root_tmpl, **kwargs)
            # delete copy of template file
            outf_.with_suffix("." + cf.template_extension).unlink()

        # Copy CAD files
        stl_path = case_folder / self.stl_path
        if not stl_path.exists():
            stl_path.mkdir(parents=True, exist_ok=True)
        for file in self.cad_files.values():
            shutil.copy(src=file, dst=stl_path)
            if not np.isclose(self.cad_scale, 1.0):
                # Scale all files
                stl_ = stl_path / file.name
                c = stl.mesh.Mesh.from_file(stl_)
                c.points *= self.cad_scale
                c.save(stl_)

        return case_folder


def box2cell_template():
    """String templated BoxToCell topological set dictionary.

    Returns
    -------
    :class:`dict`
        With a single key ``BoxToCell``whose value is a dictionary wit the
        keys ``box`` and ``fieldValues``. The values for these keys are
        :class:`string.Template` which can be interpolated.
        The box template has parameters ``box_min`` and ``box_max`` for the
        minimum and maximum values of the box.
        The fieldValues template has parameters ``field`` and ``value`` to
        specify the field to be selected and the value to be applied.
    """
    box = Template("$box_min $box_max")
    field = Template("(volScalarFieldValue $field $value)")
    return dict(boxToCell=dict(box=box, fieldValues=field))


def box2cell(*, box_min, box_max, field, value):
    """Generate a BoxToCell topological set dictionary."""
    box_min = p2f.iter2foam(box_min) if not isinstance(box_min, str) else box_min
    box_max = p2f.iter2foam(box_max) if not isinstance(box_max, str) else box_max
    if isinstance(value, Iterable) and not isinstance(value, str):
        value = p2f.iter2foam(value)

    b2c = box2cell_template()
    b2c["boxToCell"]["box"] = b2c["boxToCell"]["box"].substitute(
        box_min=box_min, box_max=box_max
    )
    b2c["boxToCell"]["fieldValues"] = b2c["boxToCell"]["fieldValues"].substitute(
        field=field, value=value
    )
    return b2c


def box2cell_from_vertices(*, bb, field, value):
    """Generate a BoxToCell topological set dictionary from vertices.

    Parameters
    ----------
    bb: :class:`numpy.ndarray`, shape (N,3)
        Vertices of the bounding box
    field: :class:`string`
        Name of the field to apply the box to
    value: numerical or iterable
        Value for the field inside the box

    Returns
    -------
    :class:`dict`
    """
    b2c = box2cell_template()
    b2c["boxToCell"]["box"] = b2c["boxToCell"]["box"].substitute(
        box_min=p2f.iter2foam(bb.min(axis=1)), box_max=p2f.iter2foam(bb.max(axis=1))
    )
    b2c["boxToCell"]["fieldValues"] = b2c["boxToCell"]["fieldValues"].substitute(
        field=field, value=value
    )
    return b2c
